<template>
  <div>
    <div class="page-content" v-if="project">
      <div
        class="repositories-section"
        style="display:flex;"
        v-if="project.repositories.length > 0"
      >
        <repository-menu :project="project"></repository-menu>
        <div class="repository-content">
          <div v-if="!selectedRepository" class="select">
            <img src="../../../assets/note_taking.svg" />
            Select a repository on the left
          </div>
          <repository v-else></repository>
        </div>
      </div>
      <div v-else class="no-repos">
        <img src="../../../assets/thinking.svg" />
        <div>
          No repositories found,
          <span @click="createRepository">create one first</span>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions, mapMutations } from "vuex";
import CreateRepository from "../../../components/modals/CreateRepository";
import RepositoryMenu from "./RepositoryMenu";
import Repository from "./Repository";
export default {
  components: {
    RepositoryMenu,
    Repository
  },
  methods: {
    ...mapActions("projectModule", ["getProject"]),
    ...mapMutations("projectModule", [
      "selectRepository",
      "unselectRepository"
    ]),
    createRepository() {
      this.$modal.show(CreateRepository, {
        project: this.project
      });
    }
  },
  computed: {
    ...mapState("projectModule", ["project", "selectedRepository"])
  },
  mounted() {
    if (!this.project) {
      this.getProject(this.$route.params.id).then(() => {
        if (this.$route.query.repository) {
          this.selectRepository(this.$route.query.repository);
        }
      });
    }
  },
  destroyed() {
    this.unselectRepository();
  }
};
</script>

<style lang="scss">
.no-repos {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  padding: 40px;
  height: 100%;
  font-weight: 600;
  img {
    width: 300px;
    margin-bottom: 15px;
  }
  span {
    text-decoration: underline;
    font-weight: bold;
  }
  span:hover {
    cursor: pointer;
  }
}
.repository-content {
  flex: 1;
  height: 100vh;
  display: flex;
  .select {
    width: 100%;
    height: 100%;
    display: flex;
    justify-content: center;
    align-items: center;
    flex-direction: column;
    font-size: 18px;
    font-weight: 600;
    img {
      height: 300px;
    }
  }
}
</style>
